=== modified file 'NEWS'
--- NEWS	2010-04-13 05:21:59 +0000
+++ NEWS	2010-04-13 08:04:45 +0000
@@ -48,6 +48,9 @@
 * ``bzr missing`` read-locks the branches only once.
   (Andrew Bennetts)
   
+* ``bzr pull`` locks the branches and tree only once.
+  (Andrew Bennetts)
+  
 * Index lookups in pack repositories search recently hit pack files first.  
   In repositories with many pack files this can greatly reduce the
   number of files accessed, the number of bytes read, and the number of

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-04-12 02:25:46 +0000
+++ bzrlib/builtins.py	2010-04-13 02:19:59 +0000
@@ -988,10 +988,14 @@
         try:
             tree_to = WorkingTree.open_containing(directory)[0]
             branch_to = tree_to.branch
+            tree_to.lock_write()
+            self.add_cleanup(tree_to.unlock)
         except errors.NoWorkingTree:
             tree_to = None
             branch_to = Branch.open_containing(directory)[0]
-        
+            branch_to.lock_write()
+            self.add_cleanup(branch_to.unlock)
+
         if local and not branch_to.get_bound_location():
             raise errors.LocalRequiresBoundBranch()
 
@@ -1027,18 +1031,15 @@
         else:
             branch_from = Branch.open(location,
                 possible_transports=possible_transports)
+            branch_from.lock_read()
+            self.add_cleanup(branch_from.unlock)
 
             if branch_to.get_parent() is None or remember:
                 branch_to.set_parent(branch_from.base)
 
-        if branch_from is not branch_to:
-            branch_from.lock_read()
-            self.add_cleanup(branch_from.unlock)
         if revision is not None:
             revision_id = revision.as_revision_id(branch_from)
 
-        branch_to.lock_write()
-        self.add_cleanup(branch_to.unlock)
         if tree_to is not None:
             view_info = _get_view_info_for_change_reporter(tree_to)
             change_reporter = delta._ChangeReporter(

